__gnu_parallel::_LoserTreeUnguardedBase< _Tp, _Compare >(3cxx)

NAME
__gnu_parallel::_LoserTreeUnguardedBase< _Tp, _Compare > - Base class for unguarded _LoserTree implementation.

SYNOPSIS

Inherited by __gnu_parallel::_LoserTreeUnguarded< __stable, _Tp, _Compare >, and __gnu_parallel::_LoserTreeUnguarded< false, _Tp, _Compare >.

  Public Member Functions

_LoserTreeUnguardedBase (unsigned int __k, const _Tp &__sentinel, _Compare __comp=std::less< _Tp >())
int __get_min_source ()
void __insert_start (const _Tp &__key, int __source, bool)

  Protected Attributes

_Compare _M_comp
unsigned int _M_ik
unsigned int _M_k
_Loser * _M_losers
unsigned int _M_offset

Detailed Description

  template<typename _Tp, typename _Compare>
class __gnu_parallel::_LoserTreeUnguardedBase< _Tp, _Compare >" Base class for unguarded _LoserTree implementation.

The whole element is copied into the tree structure.

No guarding is done, therefore not a single input sequence must run empty. Unused __sequence heads are marked with a sentinel which is > all elements that are to be merged.

This is a very fast variant.

Definition at line 574 of file losertree.h.

Author

Generated automatically by Doxygen for libstdc++ from the source code.